# Set sheet publish status

Sets the publish status of the sheet and returns the new status, including the URLs of any enabled publishings.

Endpoint: PUT /sheets/{sheetId}/publish
Version: 2.0.0
Security: APIToken, OAuth2

## Path parameters:

  - `sheetId` (number, required)
    ID of the sheet being accessed.

## Header parameters:

  - `Authorization` (string)
    API Access Token used to authenticate requests to Smartsheet APIs.

  - `smartsheet-integration-source` (string)
    Uses the following metadata to distinguish between human-initiated API requests and third-party service-initiated calls by AI Connectors or ITSM:

- Integration source type
- Organization name
- Integration source name 

Format:


TYPE,OrgName,SourceName


Examples: 

AI,SampleOrg,My-AI-Connector-v2

SCRIPT,SampleOrg2,Accounting-updater-script

APPLICATION,SampleOrg3,SheetUpdater
    Example: "AI,SampleOrg,My-AI-Connector-v2"

  - `Content-Type` (string)
    Required for POST and PUT requests. Defines the structure for the request body.

## Request fields (application/json):

  - `readOnlyFullAccessibleBy` (string)
    Indicates who can access the 'Read-Only Full' view of the published sheet:

  * ALL - available to anyone who has the link.
  * ORG - available only to members of the sheet owner's Smartsheet organization account.
  * SHARED - available only to users shared to the item.

Only returned in the response if readOnlyFullEnabled = true.
    Enum: "ALL", "ORG", "SHARED"

  - `readOnlyFullDefaultView` (string)
    Indicates which view the user has set for a read-only, default view of the     published sheet. Must be one of the listed enum values.
    Enum: "CALENDAR", "CARD", "GRID"

  - `readOnlyFullEnabled` (boolean)
    If true, a rich version of the sheet is published with the ability to download row attachments and discussions.

  - `readOnlyLiteEnabled` (boolean)
    If true, a lightweight version of the sheet is published without row attachments and discussions.

  - `readWriteAccessibleBy` (string)
    Indicates who can access the 'Edit by Anyone' view of the published sheet:

  * ALL - available to anyone who has the link.
  * ORG - available only to members of the sheet owner's Smartsheet organization account.
  * SHARED - available only to users shared to the item.

Only returned in the response if readWriteEnabled = true.
    Enum: "ALL", "ORG", "SHARED"

  - `readWriteDefaultView` (string)
    Indicates which view the user has set for a read-write, default view of the published sheet. Must be one of the listed enum values.
    Enum: "CALENDAR", "CARD", "GRID"

  - `readWriteEnabled` (boolean)
    If true,a rich version of the sheet is published with the ability to edit cells and manage attachments and discussions.

  - `readOnlyFullShowToolbar` (boolean)
    Indicates whether the left nav toolbar is displayed. The default, or true, is to display the toolbar. If false, hides the toolbar.

  - `readWriteShowToolbar` (boolean)
    Indicates whether the left nav toolbar is displayed. The default, or true, is to display the toolbar. If false, hides the toolbar.

## Response 200 fields (application/json):

  - `message` (string)
    Message that indicates the outcome of the request. (One of SUCCESS or PARTIAL_SUCCESS.)
    Enum: "PARTIAL_SUCCESS", "SUCCESS"

  - `resultCode` (number)
    * '0' Success
* '3' Partial Success of Bulk Operation
    Enum: 0, 3

  - `result` (object)
    Describes the sheet's publish settings.

  - `result.icalUrl` (any)
    URL for iCal view of the published sheet. Only returned in a response if icalEnabled = true.

  - `result.readOnlyFullUrl` (string)
    URL for 'Read-Only Full' view of the published sheet. Only returned in a response if readOnlyFullEnabled = true.

  - `result.readOnlyLiteSslUrl` (string)
    URL for 'Read-Only' view of the published sheet when SSL is enabled.

  - `result.readOnlyLiteUrl` (string)
    URL for 'Read-Only HTML' view of the published sheet. Only returned in a response if readOnlyLiteEnabled = true.

  - `result.readWriteUrl` (string)
    URL for 'Edit by Anyone' view of the published sheet. Only returned in a response if readWriteEnabled = true.

  - `result.icalEnabled` (boolean)
    If true, a webcal is available for the calendar in the sheet.

  - `result.readOnlyFullAccessibleBy` (string)
    Indicates who can access the 'Read-Only Full' view of the published sheet:

  * ALL - available to anyone who has the link.
  * ORG - available only to members of the sheet owner's Smartsheet organization account.
  * SHARED - available only to users shared to the item.

Only returned in the response if readOnlyFullEnabled = true.
    Enum: "ALL", "ORG", "SHARED"

  - `result.readOnlyFullDefaultView` (string)
    Indicates which view the user has set for a read-only, default view of the     published sheet. Must be one of the listed enum values.
    Enum: "CALENDAR", "CARD", "GRID"

  - `result.readOnlyFullEnabled` (boolean)
    If true, a rich version of the sheet is published with the ability to download row attachments and discussions.

  - `result.readOnlyLiteEnabled` (boolean)
    If true, a lightweight version of the sheet is published without row attachments and discussions.

  - `result.readWriteAccessibleBy` (string)
    Indicates who can access the 'Edit by Anyone' view of the published sheet:

  * ALL - available to anyone who has the link.
  * ORG - available only to members of the sheet owner's Smartsheet organization account.
  * SHARED - available only to users shared to the item.

Only returned in the response if readWriteEnabled = true.
    Enum: "ALL", "ORG", "SHARED"

  - `result.readWriteDefaultView` (string)
    Indicates which view the user has set for a read-write, default view of the published sheet. Must be one of the listed enum values.
    Enum: "CALENDAR", "CARD", "GRID"

  - `result.readWriteEnabled` (boolean)
    If true,a rich version of the sheet is published with the ability to edit cells and manage attachments and discussions.

  - `result.readOnlyFullShowToolbar` (boolean)
    Indicates whether the left nav toolbar is displayed. The default, or true, is to display the toolbar. If false, hides the toolbar.

  - `result.readWriteShowToolbar` (boolean)
    Indicates whether the left nav toolbar is displayed. The default, or true, is to display the toolbar. If false, hides the toolbar.

## Response default fields (application/json):

  - `refId` (string)
    The ID of the specific error occurrence. Please include this information when contacting Smartsheet support.

  - `errorCode` (number)
    Custom error code from Smartsheet. See the complete [Error Code List](/api/smartsheet/error-codes).

  - `message` (string)
    Descriptive error message.


